/******************************************************************************
 *    GetObjectParamsDirect.cpp
 *
 *    This file is part of Object Script Library
 *    Copyright (C) 2005-2009 Tom N Harris <telliamed@whoopdedo.org>
 *
 *    Permission is hereby granted, free of charge, to any person obtaining
 *    a copy of this software and associated documentation files (the 
 *    "Software"), to deal in the Software without restriction, including 
 *    without limitation the rights to use, copy, modify, merge, publish, 
 *    distribute, sublicense, and/or sell copies of the Software, and to 
 *    permit persons to whom the Software is furnished to do so.
 *    
 *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 *    OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-
 *    INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 
 *    BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN 
 *    AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR 
 *    IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
 *    THE SOFTWARE.
 *
 *****************************************************************************/

#include "ScriptLib.h"

#include <string.h>

extern const char* g_pszDesignNote;

char* GetObjectParamsDirect(int iObject)
{
	SInterface<IPropertyManager> pPM(g_pScriptManager);
	SInterface<IProperty> pProp;
	pProp = pPM->GetPropertyNamed(g_pszDesignNote);
	if (!pProp)
		thrown null_pointer();
	if (!pProp->IsSimplyRelevant(iObject))
		return NULL;
	IStringProperty* pDNProp;
	const char* pszDesignNote;
	char* pszRet;
	if (E_NOINTERFACE == pProp->QueryInterface(IID_IStringProperty, reinterpret_cast<void**>(&pDNProp)))
		throw no_interface("IStringProperty");
	pDNProp->GetSimple(iObject, &pszDesignNote);
	pszRet = reinterpret_cast<char*>(g_pMalloc->Alloc(strlen(pszDesignNote) + 1));
	if (pszRet)
		strcpy(pszRet, pszDesignNote);
	pDNProp->Release();
	return pszRet;
}
